Index: serefpolicy-contrib-20140730/mozilla.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/mozilla.fc
+++ serefpolicy-contrib-20140730/mozilla.fc
@@ -1,38 +1,72 @@
-HOME_DIR/\.galeon(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
-HOME_DIR/\.mozilla(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
-HOME_DIR/\.mozilla/plugins(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/\.netscape(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
-HOME_DIR/\.phoenix(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
-
-HOME_DIR/\.adobe(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/\.macromedia(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/\.gnash(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/\.gcjwebplugin(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/\.icedteaplugin(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/\.spicec(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/\.ICAClient(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-HOME_DIR/zimbrauserdata(/.*)?	gen_context(system_u:object_r:mozilla_plugin_home_t,s0)
-
-/usr/bin/epiphany	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/bin/epiphany-bin	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/bin/mozilla	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
+HOME_DIR/\.config/chromium(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.galeon(/.*)?			gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.java(/.*)?			gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.mozilla(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.cache/mozilla(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.cache/icedtea-web(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.thunderbird(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/POkemon.*(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.netscape(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.phoenix(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.adobe(/.*)?			gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.macromedia(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.gnash(/.*)?			gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.webex(/.*)?			gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.gnashpluginrc		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/abc			-- 	gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.gcjwebplugin(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.grl-podcasts(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.icedteaplugin(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.icedtea(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.juniper_networks(/.*)?	gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.lyx(/.*)?                   gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.quakelive(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.spicec(/.*)?			gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.ICAClient(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/\.IBMERS(/.*)?          	gen_context(system_u:object_r:mozilla_home_t,s0)
+HOME_DIR/zimbrauserdata(/.*)?		gen_context(system_u:object_r:mozilla_home_t,s0)
+#
+# /bin
+#
+/usr/bin/netscape		--	gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/bin/mozilla		--	gen_context(system_u:object_r:mozilla_exec_t,s0)
 /usr/bin/mozilla-snapshot	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/bin/epiphany-bin		--	gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/bin/epiphany		--	gen_context(system_u:object_r:mozilla_exec_t,s0)
 /usr/bin/mozilla-[0-9].*	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
 /usr/bin/mozilla-bin-[0-9].*	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/bin/netscape	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/bin/nspluginscan	--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
-/usr/bin/nspluginviewer	--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
-
-/usr/lib/[^/]*firefox[^/]*/firefox	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/[^/]*firefox[^/]*/firefox-bin	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/firefox[^/]*/mozilla-.*	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/galeon/galeon	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/iceweasel/iceweasel	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/mozilla[^/]*/reg.+	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/mozilla[^/]*/mozilla-.*	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/mozilla/plugins-wrapped(/.*)?	gen_context(system_u:object_r:mozilla_plugin_rw_t,s0)
-/usr/lib/netscape/base-4/wrapper	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
-/usr/lib/netscape/.+/communicator/communicator-smotif\.real	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
+
+ifdef(`distro_redhat',`
+/usr/bin/nspluginscan		--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
+/usr/bin/nspluginviewer		--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
 /usr/lib/nspluginwrapper/npviewer.bin	--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
-/usr/lib/nspluginwrapper/plugin-config	--	gen_context(system_u:object_r:mozilla_plugin_config_exec_t,s0)
-/usr/lib/xulrunner[^/]*/plugin-container	--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
+')
+
+ifdef(`distro_debian',`
+/usr/lib/iceweasel/iceweasel	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
+')
+
+#
+# /lib
+#
+
+/usr/lib/galeon/galeon 	--	gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/lib/netscape/.+/communicator/communicator-smotif\.real -- gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/lib/netscape/base-4/wrapper -- gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/lib/mozilla[^/]*/reg.+ --	gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/lib/mozilla[^/]*/mozilla-.* -- gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/lib/firefox[^/]*/mozilla-.* -- gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/lib/[^/]*firefox[^/]*/firefox-bin -- gen_context(system_u:object_r:mozilla_exec_t,s0)
+/usr/lib/[^/]*firefox[^/]*/firefox -- gen_context(system_u:object_r:mozilla_exec_t,s0)
+
+/usr/lib/xulrunner[^/]*/plugin-container		--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
+
+/usr/lib/firefox/plugin-container		--	gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
+
+/usr/lib/mozilla/plugins-wrapped(/.*)?			gen_context(system_u:object_r:mozilla_plugin_rw_t,s0)
+
+/usr/libexec/WebKitPluginProcess    --   gen_context(system_u:object_r:mozilla_plugin_exec_t,s0)
+
+ifdef(`distro_redhat',`
+/usr/lib/nspluginwrapper/plugin-config			--	gen_context(system_u:object_r:mozilla_plugin_config_exec_t,s0)
+')
Index: serefpolicy-contrib-20140730/mozilla.if
===================================================================
--- serefpolicy-contrib-20140730.orig/mozilla.if
+++ serefpolicy-contrib-20140730/mozilla.if
@@ -1,146 +1,75 @@
-## <summary>Policy for Mozilla and related web browsers.</summary>
+## <summary>Policy for Mozilla and related web browsers</summary>
 
 ########################################
 ## <summary>
-##	Role access for mozilla.
+##	Role access for mozilla
 ## </summary>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	Role allowed access
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	User domain for the role.
+##	User domain for the role
 ##	</summary>
 ## </param>
 #
 interface(`mozilla_role',`
 	gen_require(`
 		type mozilla_t, mozilla_exec_t, mozilla_home_t;
-		type mozilla_tmp_t, mozilla_tmpfs_t, mozilla_plugin_tmp_t;
-		type mozilla_plugin_tmpfs_t, mozilla_plugin_home_t;
 		attribute_role mozilla_roles;
 	')
 
-	########################################
-	#
-	# Declarations
-	#
-
 	roleattribute $1 mozilla_roles;
 
-	########################################
-	#
-	# Policy
-	#
-
-	domtrans_pattern($2, mozilla_exec_t, mozilla_t)
+	domain_auto_trans($2, mozilla_exec_t, mozilla_t)
+	# Unrestricted inheritance from the caller.
+	allow $2 mozilla_t:process { noatsecure siginh rlimitinh };
+	allow mozilla_t $2:fd use;
+	allow mozilla_t $2:process { sigchld signull };
+	allow mozilla_t $2:unix_stream_socket connectto;
 
-	allow $2 mozilla_t:process { noatsecure siginh rlimitinh ptrace signal_perms };
+	# Allow the user domain to signal/ps.
 	ps_process_pattern($2, mozilla_t)
-
-	allow mozilla_t $2:process signull;
-	allow mozilla_t $2:unix_stream_socket connectto;
+	allow $2 mozilla_t:process signal_perms;
 
 	allow $2 mozilla_t:fd use;
-	allow $2 mozilla_t:shm rw_shm_perms;
-
-	stream_connect_pattern($2, mozilla_tmpfs_t, mozilla_tmpfs_t, mozilla_t)
+	allow $2 mozilla_t:shm { associate getattr };
+	allow $2 mozilla_t:shm { unix_read unix_write };
+	allow $2 mozilla_t:unix_stream_socket connectto;
+
+	# X access, Home files
+	manage_dirs_pattern($2, mozilla_home_t, mozilla_home_t)
+	manage_files_pattern($2, mozilla_home_t, mozilla_home_t)
+	manage_lnk_files_pattern($2, mozilla_home_t, mozilla_home_t)
+	relabel_dirs_pattern($2, mozilla_home_t, mozilla_home_t)
+	relabel_files_pattern($2, mozilla_home_t, mozilla_home_t)
+	relabel_lnk_files_pattern($2, mozilla_home_t, mozilla_home_t)
+
+	#should be remove then with adding of roleattribute
+	mozilla_run_plugin(mozilla_t, $1)
+	mozilla_dbus_chat($2)
 
-	allow $2 { mozilla_home_t mozilla_plugin_home_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { mozilla_home_t mozilla_plugin_home_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 mozilla_home_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".galeon")
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".mozilla")
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".netscape")
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".phoenix")
-
-	filetrans_pattern($2, mozilla_home_t, mozilla_plugin_home_t, dir, "plugins")
-
-	allow $2 { mozilla_tmp_t mozilla_plugin_tmp_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { mozilla_tmp_t mozilla_plugin_tmp_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 mozilla_plugin_tmp_t:fifo_file { manage_fifo_file_perms relabel_fifo_file_perms };
-
-	allow $2 { mozilla_tmpfs_t mozilla_plugin_tmpfs_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { mozilla_tmpfs_t mozilla_plugin_tmpfs_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 { mozilla_tmpfs_t mozilla_plugin_tmpfs_t }:fifo_file { manage_fifo_file_perms relabel_fifo_file_perms };
-	allow $2 { mozilla_tmpfs_t mozilla_plugin_tmpfs_t }:sock_file { manage_sock_file_perms relabel_sock_file_perms };
+	userdom_manage_tmp_role($1, mozilla_t)
 
 	optional_policy(`
-		mozilla_dbus_chat($2)
+		nsplugin_role($1, mozilla_t)
 	')
-')
 
-########################################
-## <summary>
-##	Role access for mozilla plugin.
-## </summary>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
-## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
-## </param>
-#
-interface(`mozilla_role_plugin',`
-	gen_require(`
-		type mozilla_plugin_tmp_t, mozilla_plugin_tmpfs_t, mozilla_plugin_rw_t;
-		type mozilla_home_t;
+	optional_policy(`
+		pulseaudio_role($1, mozilla_t)
+		pulseaudio_filetrans_admin_home_content(mozilla_t)
+		pulseaudio_filetrans_home_content(mozilla_t)
 	')
 
-	mozilla_run_plugin($2, $1)
-	mozilla_run_plugin_config($2, $1)
+	mozilla_filetrans_home_content($2)
 
-	allow $2 { mozilla_plugin_t mozilla_plugin_config_t }:process { ptrace signal_perms };
-	ps_process_pattern($2, { mozilla_plugin_t mozilla_plugin_config_t })
-
-	allow $2 mozilla_plugin_t:unix_stream_socket rw_socket_perms;
-	allow $2 mozilla_plugin_t:fd use;
-
-	stream_connect_pattern($2, mozilla_plugin_tmpfs_t, mozilla_plugin_tmpfs_t, mozilla_plugin_t)
-
-	allow mozilla_plugin_t $2:process signull;
-	allow mozilla_plugin_t $2:unix_stream_socket { connectto rw_socket_perms };
-	allow mozilla_plugin_t $2:unix_dgram_socket { sendto rw_socket_perms };
-	allow mozilla_plugin_t $2:shm { rw_shm_perms destroy };
-	allow mozilla_plugin_t $2:sem create_sem_perms;
-
-	allow $2 mozilla_home_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 mozilla_home_t:file { manage_file_perms relabel_file_perms };
-	allow $2 mozilla_home_t:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".galeon")
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".mozilla")
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".netscape")
-	userdom_user_home_dir_filetrans($2, mozilla_home_t, dir, ".phoenix")
-
-	allow $2 mozilla_plugin_tmp_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 mozilla_plugin_tmp_t:file { manage_file_perms relabel_file_perms };
-	allow $2 mozilla_plugin_tmp_t:fifo_file { manage_fifo_file_perms relabel_fifo_file_perms };
-
-	allow $2 mozilla_plugin_tmpfs_t:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 mozilla_plugin_tmpfs_t:file { manage_file_perms relabel_file_perms };
-	allow $2 mozilla_plugin_tmpfs_t:fifo_file { manage_fifo_file_perms relabel_fifo_file_perms };
-	allow $2 mozilla_plugin_tmpfs_t:sock_file { manage_sock_file_perms relabel_sock_file_perms };
-
-	allow $2 mozilla_plugin_rw_t:dir list_dir_perms;
-	allow $2 mozilla_plugin_rw_t:file read_file_perms;
-	allow $2 mozilla_plugin_rw_t:lnk_file read_lnk_file_perms;
-
-	can_exec($2, mozilla_plugin_rw_t)
-
-	optional_policy(`
-		mozilla_dbus_chat_plugin($2)
-	')
 ')
 
 ########################################
 ## <summary>
-##	Read mozilla home directory content.
+##	Read mozilla home directory content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -153,15 +82,15 @@ interface(`mozilla_read_user_home_files'
 		type mozilla_home_t;
 	')
 
-	userdom_search_user_home_dirs($1)
 	allow $1 mozilla_home_t:dir list_dir_perms;
 	allow $1 mozilla_home_t:file read_file_perms;
 	allow $1 mozilla_home_t:lnk_file read_lnk_file_perms;
+	userdom_search_user_home_dirs($1)
 ')
 
 ########################################
 ## <summary>
-##	Write mozilla home directory files.
+##	Write mozilla home directory content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -174,14 +103,13 @@ interface(`mozilla_write_user_home_files
 		type mozilla_home_t;
 	')
 
-	userdom_search_user_home_dirs($1)
 	write_files_pattern($1, mozilla_home_t, mozilla_home_t)
+	userdom_search_user_home_dirs($1)
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read and
-##	write mozilla home directory files.
+##	Dontaudit attempts to read/write mozilla home directory content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -194,14 +122,12 @@ interface(`mozilla_dontaudit_rw_user_hom
 		type mozilla_home_t;
 	')
 
-	dontaudit $1 mozilla_home_t:file rw_file_perms;
+	dontaudit $1 mozilla_home_t:file rw_inherited_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempt to Create,
-##	read, write, and delete mozilla
-##	home directory content.
+##	Dontaudit attempts to write mozilla home directory content
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -216,12 +142,11 @@ interface(`mozilla_dontaudit_manage_user
 
 	dontaudit $1 mozilla_home_t:dir manage_dir_perms;
 	dontaudit $1 mozilla_home_t:file manage_file_perms;
-	dontaudit $1 mozilla_home_t:lnk_file manage_lnk_file_perms;
 ')
 
 ########################################
 ## <summary>
-##	Execute mozilla home directory files.  (Deprecated)
+##	Execute mozilla home directory content.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -230,33 +155,16 @@ interface(`mozilla_dontaudit_manage_user
 ## </param>
 #
 interface(`mozilla_exec_user_home_files',`
-	refpolicywarn(`$0($*) has been deprecated, use mozilla_exec_user_plugin_home_files() instead.')
-	mozilla_exec_user_plugin_home_files($1)
-')
-
-########################################
-## <summary>
-##	Execute mozilla plugin home directory files.
-## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-#
-interface(`mozilla_exec_user_plugin_home_files',`
 	gen_require(`
-		type mozilla_home_t, mozilla_plugin_home_t;
+		type mozilla_home_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	exec_files_pattern($1, { mozilla_home_t mozilla_plugin_home_t }, mozilla_plugin_home_t)
+	can_exec($1, mozilla_home_t)
 ')
 
 ########################################
 ## <summary>
-##	Mozilla home directory file
-##	text relocation.  (Deprecated)
+##	Execmod mozilla home directory content.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -265,140 +173,156 @@ interface(`mozilla_exec_user_plugin_home
 ## </param>
 #
 interface(`mozilla_execmod_user_home_files',`
-	refpolicywarn(`$0($*) has been deprecated, use mozilla_execmod_user_plugin_home_files() instead.')
-	mozilla_execmod_user_plugin_home_files($1)
+	gen_require(`
+		type mozilla_home_t;
+	')
+
+	allow $1 mozilla_home_t:file execmod;
 ')
 
 ########################################
 ## <summary>
-##	Mozilla plugin home directory file
-##	text relocation.
+##	Run mozilla in the mozilla domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
 #
-interface(`mozilla_execmod_user_plugin_home_files',`
+interface(`mozilla_domtrans',`
 	gen_require(`
-		type mozilla_plugin_home_t;
+		type mozilla_t, mozilla_exec_t;
 	')
 
-	allow $1 mozilla_plugin_home_t:file execmod;
+	domtrans_pattern($1, mozilla_exec_t, mozilla_t)
 ')
 
 ########################################
 ## <summary>
-##	Run mozilla in the mozilla domain.
+##	Execute a mozilla_exec_t in the specified domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed to transition.
 ##	</summary>
 ## </param>
+## <param name="target_domain">
+##	<summary>
+##	The type of the new process.
+##	</summary>
+## </param>
 #
-interface(`mozilla_domtrans',`
+interface(`mozilla_domtrans_spec',`
 	gen_require(`
-		type mozilla_t, mozilla_exec_t;
+		type mozilla_exec_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, mozilla_exec_t, mozilla_t)
+	domain_entry_file($2, mozilla_exec_t)
+	domtrans_pattern($1, mozilla_exec_t, $2)
 ')
 
 ########################################
 ## <summary>
-##	Execute a domain transition to
-##	run mozilla plugin.
+##	Execute a domain transition to run mozilla_plugin.
 ## </summary>
 ## <param name="domain">
 ## <summary>
-##	Domain allowed to transition.
+##	Domain allowed access.
 ## </summary>
 ## </param>
 #
 interface(`mozilla_domtrans_plugin',`
 	gen_require(`
 		type mozilla_plugin_t, mozilla_plugin_exec_t;
+		type mozilla_plugin_config_t, mozilla_plugin_config_exec_t;
+		type mozilla_plugin_rw_t;
+		class dbus send_msg;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, mozilla_plugin_exec_t, mozilla_plugin_t)
+	domtrans_pattern($1, mozilla_plugin_config_exec_t, mozilla_plugin_config_t)
+	allow mozilla_plugin_t $1:process signull;
+	dontaudit mozilla_plugin_config_t $1:file read_inherited_file_perms;
+	dontaudit mozilla_plugin_t $1:process signal;
+	allow $1 mozilla_plugin_t:unix_stream_socket { connectto rw_socket_perms };
+	allow $1 mozilla_plugin_t:fd use;
+
+	allow mozilla_plugin_t $1:unix_stream_socket rw_socket_perms;
+	allow mozilla_plugin_t $1:unix_dgram_socket { sendto rw_socket_perms };
+	allow mozilla_plugin_t $1:shm { rw_shm_perms destroy };
+	allow mozilla_plugin_t $1:sem create_sem_perms;
+	allow $1 mozilla_plugin_t:sem rw_sem_perms;
+	allow $1 mozilla_plugin_t:shm rw_shm_perms;
+
+	ps_process_pattern($1, mozilla_plugin_t)
+	ps_process_pattern(mozilla_plugin_t, $1)
+	allow $1 mozilla_plugin_t:process { signal_perms noatsecure };
+
+	list_dirs_pattern($1, mozilla_plugin_rw_t, mozilla_plugin_rw_t)
+	read_files_pattern($1, mozilla_plugin_rw_t, mozilla_plugin_rw_t)
+	read_lnk_files_pattern($1, mozilla_plugin_rw_t, mozilla_plugin_rw_t)
+	can_exec($1, mozilla_plugin_rw_t)
+
+	allow $1 mozilla_plugin_t:dbus send_msg;
+	allow mozilla_plugin_t $1:dbus send_msg;
+
+	allow mozilla_plugin_t $1:process signull;
 ')
 
 ########################################
 ## <summary>
-##	Execute mozilla plugin in the
-##	mozilla plugin domain, and allow
-##	the specified role the mozilla
-##	plugin domain.
+##	Execute mozilla_plugin in the mozilla_plugin domain, and
+##	allow the specified role the mozilla_plugin domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed access
 ##	</summary>
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to be allowed the mozilla_plugin domain.
 ##	</summary>
 ## </param>
 #
 interface(`mozilla_run_plugin',`
 	gen_require(`
-		attribute_role mozilla_plugin_roles;
+		type mozilla_plugin_t;
+		attribute_role mozilla_plugin_roles, mozilla_plugin_config_roles;
 	')
 
 	mozilla_domtrans_plugin($1)
 	roleattribute $2 mozilla_plugin_roles;
-')
+	roleattribute $2 mozilla_plugin_config_roles;
 
-########################################
-## <summary>
-##	Execute a domain transition to
-##	run mozilla plugin config.
-## </summary>
-## <param name="domain">
-## <summary>
-##	Domain allowed to transition.
-## </summary>
-## </param>
-#
-interface(`mozilla_domtrans_plugin_config',`
-	gen_require(`
-		type mozilla_plugin_config_t, mozilla_plugin_config_exec_t;
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 mozilla_plugin_t:process ptrace;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, mozilla_plugin_config_exec_t, mozilla_plugin_config_t)
+	optional_policy(`
+		lpd_run_lpr(mozilla_plugin_t, $2)
+	')
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Execute mozilla plugin config in
-##	the mozilla plugin config domain,
-##	and allow the specified role the
-##	mozilla plugin config domain.
+##  Execute qemu unconfined programs in the role.
 ## </summary>
-## <param name="domain">
-##	<summary>
-##	Domain allowed to transition.
-##	</summary>
-## </param>
 ## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
+##  <summary>
+##  The role to allow the mozilla_plugin domain.
+##  </summary>
 ## </param>
+## <rolecap/>
 #
-interface(`mozilla_run_plugin_config',`
-	gen_require(`
-		attribute_role mozilla_plugin_config_roles;
-	')
+interface(`mozilla_role_plugin',`
+    gen_require(`
+		attribute_role mozilla_plugin_roles, mozilla_plugin_config_roles;
+    ')
 
-	mozilla_domtrans_plugin_config($1)
-	roleattribute $2 mozilla_plugin_config_roles;
+    roleattribute $1 mozilla_plugin_roles;
+    roleattribute $1 mozilla_plugin_config_roles;
 ')
 
 ########################################
@@ -424,8 +348,7 @@ interface(`mozilla_dbus_chat',`
 
 ########################################
 ## <summary>
-##	Send and receive messages from
-##	mozilla plugin over dbus.
+##	read/write mozilla per user tcp_socket
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -433,76 +356,144 @@ interface(`mozilla_dbus_chat',`
 ##	</summary>
 ## </param>
 #
-interface(`mozilla_dbus_chat_plugin',`
+interface(`mozilla_rw_tcp_sockets',`
 	gen_require(`
-		type mozilla_plugin_t;
-		class dbus send_msg;
+		type mozilla_t;
 	')
 
-	allow $1 mozilla_plugin_t:dbus send_msg;
-	allow mozilla_plugin_t $1:dbus send_msg;
+	allow $1 mozilla_t:tcp_socket rw_socket_perms;
 ')
 
-########################################
+#######################################
 ## <summary>
-##	Read and write mozilla TCP sockets.
+##  Read mozilla_plugin tmpfs files
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access
+##  </summary>
 ## </param>
 #
-interface(`mozilla_rw_tcp_sockets',`
-	gen_require(`
-		type mozilla_t;
-	')
+interface(`mozilla_plugin_read_tmpfs_files',`
+    gen_require(`
+        type mozilla_plugin_tmpfs_t;
+    ')
 
-	allow $1 mozilla_t:tcp_socket rw_socket_perms;
+    allow $1 mozilla_plugin_tmpfs_t:file read_file_perms;
+')
+
+#######################################
+## <summary>
+##  Read/Write mozilla_plugin tmpfs files
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access
+##  </summary>
+## </param>
+#
+interface(`mozilla_plugin_rw_tmpfs_files',`
+    gen_require(`
+        type mozilla_plugin_tmpfs_t;
+    ')
+
+    rw_files_pattern($1, mozilla_plugin_tmpfs_t, mozilla_plugin_tmpfs_t)
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	mozilla plugin rw files.
+##	Delete mozilla_plugin tmpfs files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed access
 ##	</summary>
 ## </param>
 #
-interface(`mozilla_manage_plugin_rw_files',`
+interface(`mozilla_plugin_delete_tmpfs_files',`
 	gen_require(`
-		type mozilla_plugin_rw_t;
+		type mozilla_plugin_tmpfs_t;
 	')
 
-	libs_search_lib($1)
-	manage_files_pattern($1, mozilla_plugin_rw_t, mozilla_plugin_rw_t)
+	allow $1 mozilla_plugin_tmpfs_t:file delete_file_perms;
+')
+
+#######################################
+## <summary>
+##      Dontaudit generict ipc read/write to a mozilla_plugin
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain to not audit.
+##      </summary>
+## </param>
+#
+interface(`mozilla_plugin_dontaudit_rw_sem',`
+        gen_require(`
+                type mozilla_plugin_t;
+        ')
+
+        dontaudit $1 mozilla_plugin_t:sem { associate unix_read unix_write };
+')
+
+#######################################
+## <summary>
+##      Allow generict ipc read/write to a mozilla_plugin
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain to not audit.
+##      </summary>
+## </param>
+#
+interface(`mozilla_plugin_rw_sem',`
+        gen_require(`
+                type mozilla_plugin_t;
+        ')
+
+        allow $1 mozilla_plugin_t:sem { associate unix_read unix_write };
 ')
 
 ########################################
 ## <summary>
-##	Read mozilla_plugin tmpfs files.
+##	Dontaudit read/write to a mozilla_plugin leaks
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`mozilla_plugin_read_tmpfs_files',`
+interface(`mozilla_plugin_dontaudit_leaks',`
 	gen_require(`
-		type mozilla_plugin_tmpfs_t;
+		type mozilla_plugin_t;
 	')
 
-	fs_search_tmpfs($1)
-	allow $1 mozilla_plugin_tmpfs_t:file read_file_perms;
+	dontaudit $1 mozilla_plugin_t:unix_stream_socket { read write };
+')
+
+#######################################
+## <summary>
+##  Dontaudit read/write to a mozilla_plugin tmp files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain to not audit.
+##  </summary>
+## </param>
+#
+interface(`mozilla_plugin_dontaudit_rw_tmp_files',`
+    gen_require(`
+        type mozilla_plugin_tmp_t;
+    ')
+
+    dontaudit $1 mozilla_plugin_tmp_t:file { read write };
 ')
 
 ########################################
 ## <summary>
-##	Delete mozilla_plugin tmpfs files.
+##	Create, read, write, and delete
+##	mozilla_plugin rw files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -510,19 +501,18 @@ interface(`mozilla_plugin_read_tmpfs_fil
 ##	</summary>
 ## </param>
 #
-interface(`mozilla_plugin_delete_tmpfs_files',`
+interface(`mozilla_plugin_manage_rw_files',`
 	gen_require(`
-		type mozilla_plugin_tmpfs_t;
+		type mozilla_plugin_rw_t;
 	')
 
-	fs_search_tmpfs($1)
-	allow $1 mozilla_plugin_tmpfs_t:file delete_file_perms;
+	allow $1 mozilla_plugin_rw_t:file manage_file_perms;
+	allow $1 mozilla_plugin_rw_t:dir rw_dir_perms;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	generic mozilla plugin home content.
+##	read mozilla_plugin rw files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -530,45 +520,57 @@ interface(`mozilla_plugin_delete_tmpfs_f
 ##	</summary>
 ## </param>
 #
-interface(`mozilla_manage_generic_plugin_home_content',`
+interface(`mozilla_plugin_read_rw_files',`
 	gen_require(`
-		type mozilla_plugin_home_t;
+		type mozilla_plugin_rw_t;
 	')
 
-	userdom_search_user_home_dirs($1)
-	allow $1 mozilla_plugin_home_t:dir manage_dir_perms;
-	allow $1 mozilla_plugin_home_t:file manage_file_perms;
-	allow $1 mozilla_plugin_home_t:fifo_file manage_fifo_file_perms;
-	allow $1 mozilla_plugin_home_t:lnk_file manage_lnk_file_perms;
-	allow $1 mozilla_plugin_home_t:sock_file manage_sock_file_perms;
+	read_files_pattern($1, mozilla_plugin_rw_t, mozilla_plugin_rw_t)
 ')
 
 ########################################
 ## <summary>
-##	Create objects in user home
-##	directories with the generic mozilla
-##	plugin home type.
+##	Create mozilla content in the user home directory
+##	with an correct label.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="object_class">
-##	<summary>
-##	Class of the object being created.
-##	</summary>
-## </param>
-## <param name="name" optional="true">
-##	<summary>
-##	The name of the object being created.
-##	</summary>
-## </param>
 #
-interface(`mozilla_home_filetrans_plugin_home',`
+interface(`mozilla_filetrans_home_content',`
+
 	gen_require(`
-		type mozilla_plugin_home_t;
+		type mozilla_home_t;
 	')
 
-	userdom_user_home_dir_filetrans($1, mozilla_plugin_home_t, $2, $3)
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".galeon")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".java")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".mozilla")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".thunderbird")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".netscape")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".phoenix")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".adobe")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".macromedia")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".gnash")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".grl-podcasts")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".gcjwebplugin")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".icedteaplugin")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".icedtea")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, file, "abc")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".quakelive")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".spicec")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".ICAClient")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, "zimbrauserdata")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".juniper_networks")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".lyx")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".IBMERS")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, file, ".gnashpluginrc")
+	userdom_user_home_dir_filetrans($1, mozilla_home_t, dir, ".webex")
+	optional_policy(`
+		gnome_cache_filetrans($1, mozilla_home_t, dir, "mozilla")
+		gnome_cache_filetrans($1, mozilla_home_t, dir, "icedtea-web")
+	')
 ')
+
